Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: New Function Estimated time: 0.00 hour

Target version: CoCoALib-0.99900 Spent time: 0.25 hour

Description

Make a class so that indexed indets from a polyring can be used with their "natural" indexes (rather than, say, c++ vector indexes).

  PolyRing P = NewPolyRing(RingQQ(), SymbolRange("x",1,4));

  IndexedIndet x(P,"x");

  cout << x(3) << endl; // prints x[3]

 

Note that square brackets can be overloaded, but only with a single arg.

Round brackets can be overloaded with several args -- I suggest overloads for 1,2,3 long and vector<long>

Related issues:

Related to CoCoA-5 - Feature #1469: Get indexed indets from a polyring New 25 Jun 2020

History

#1 - 25 Jun 2020 09:48 - John Abbott

- Related to Feature #1469: Get indexed indets from a polyring added

#2 - 25 Jun 2020 09:51 - John Abbott

- Description updated

As usual, indexes should be of type long (no need for BigInt).

It seems reasonable to allow a "short-cut" for up to 3 indexes; certainly 1 and 2, but why not 3 as well?

Probably not worth overloading operator[]; it might be confusing to a C++ reader (who would think of a vector),

and it works only for 1 index, while operator() can be made more flexible.

#3 - 07 Mar 2024 20:36 - John Abbott

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99900
